#! ruby -Ks
  # coding: Shift_JIS
  # sample for exlap_c ver 1.3  2011/06/28
require "./exlap_s"
include Exl

wb = ExlBook.new
wb.author = wb.last_author = "؉Ԏq"
wb.company = "NPOx"

    # csv̎捞
csv_str = "awk,perl\n" + "python,ruby\n"
wb.push(csv_str)
wb.sheets.last.name = "#1 csv̎捞"  # [NV[g

    # Qz̎捞
ary = [
    ['apple',    'lemon'],
    ['orange', 'peach']]
wb.push(ary)
wb.sheets.last.name = "#2 Qz̎捞"

    # font̕t
ss = ExlSheet.new
ss.name = "#3 font̕t"
ary = [%w(snow White), %w(sky Blue), %w(earth), %w(sun Red)]
rng = ss.range(0,0, 1,1)  # 2~2̗̈RangeƂĐݒ
rng.each {|cell|
  break  if ary.size == 0
  data, color = ary.shift
  cell.Data = data
  cell.Font.Color = color  if color
  cell.Interior.Color = "Black"  if color == "White"
}
wb.push(ss)

    # rEn_̐ݒ
ary = [%w(desk chair), %w(pencil note)]
ss = ExlSheet.new(ary)
ss.name = "#4 rEn_̐ݒ"
ss.start_rc = [1,1]  # n_B2ɂ
ss.used_range.allbox()
wb.push(ss)

    # ̔zu(3~3̃Zɂzu)
ss = ExlSheet.new
ss.name = "#5 ̔zu"
ary = [%w(dog Left Top), %w(cat Center Center),
    %w(cow Left Bottom), %w(horse Right Bottom)]
height = 3  # č
width = 3  # ̌
[0, height].each {|y|
  [0, width].each {|x|
    rng = ss.range(y,x, y+height-1, x+width-1)
    cell = rng.cell(0,0)  # Range̍[̃Z
    data, horizontal, vertical = ary.shift
    cell.Data = data
    cell.Alignment.Horizontal = horizontal
    cell.Alignment.Vertical = vertical
    rng.merge_cells = true  # Z
  }
}
wb.push(ss)

    # l̕\`(_Q܂ŕ\)
ary = [
    [56, 12.4, 35.42],
    [234.8, 94, 39.1]]
ss = ExlSheet.new(ary)
ss.name = "#6 l̕\`"
ss.used_range.each {|cell|
  cell.NumberFormat = "##0.00"
}
wb.push(ss)

    # \`ꂱ(001蓙ւ̑Ή̗lq)
csv_str = <<EOS1
001,"1,234",123,12
002,50%,3.14%,"1,234%"
003,2010/10/07,2010N10W,QQNPOX
004,01:14,15:32:08
EOS1
wb.csv_push(csv_str)
wb.sheets.last.name = "#7 \`ꂱ"

    # ֐̐ݒ
formula1 = "=SUM(RC[-3]:RC[-1])"
$formula[formula1] = <<SCR1
  total = 0
  aa[rn][cn-3..cn-1].each do |cell|
    total += getData(cell).to_i
  end
  data = total
SCR1
formula2 = "=LOWER(RC[-1])"
$formula[formula2] = "data = getData(aa[rn][cn-1]).to_s.tr('A-Z', 'a-z')"
ss = ExlSheet.new
ss.name = "#8 ֐̐ݒ"
ss.range(0,0, 0,3).Data = [5, 6, 7, 5+6+7]
ss.cell(0,3).Formula = formula1
ss.range(1,0, 1,1).Data = ["ABC", "abc"]
ss.cell(1,1).Formula = formula2
wb.push(ss)

    # \Pʂłfontݒ
ary = [%w(grass leaf), %w(tree forest)]
ss = ExlSheet.new(ary)
ss.name = "#9 \Pʂłfontݒ"
ss.tbl = eFont("Green").mrg( eBorder() )
wb.push(ss)

    # Pʂłfontݒ
ary = [%w(linux FreeBSD), %w(Windows android)]
ss = ExlSheet.new(ary)
ss.name = "#10 Pʂłfontݒ"
ss.col = [eFont("Brown"), eFont("Cyan")]
wb.push(ss)

    # sPʂłfontݒ
ary = [%w(bicycle car), %w(ship train)]
ss = ExlSheet.new(ary)
ss.name = "#11 sPʂłfontݒ"
ss.row[0] = eFont("Magenta")
ss.row[1] = eFont("White")
ss.row[1].Interior.Color = "Black"
wb.push(ss)

    # Ifont̕t(String@html)
ss = ExlSheet.new
ss.name = "#12 Ifont̕t"
ss.col = [eWidth(36), eWidth(36)]  # 񕝂̐ݒ
rng = ss.range(0,0, 1,1)
rng.Data = [
  'L[[h<I>xmlss</I><Font>(C^bN)łD</Font>',
  'L[[h<B>ruby</B><Font>()łD</Font>',
  'L[[h<U>SpreadSheet</U><Font>()łD</Font>',
  'L[[h<Font html:Color="Red">Excel</Font><Font>(ԐF)łD</Font>']
rng.each {|cell|
  cell.Type = 'String@html'
}
wb.push(ss)

    # ӂ肪
ary = [
  %w(SR LV^JC),
  %w(Nq^ NVqEw),
  %w(Ho EJgEZ),
  %w(c KfCXC)]
ss = ExlSheet.new
ss.name = "#13 ӂ肪"
rng = ss.range(0,0, 3,1)  # SsEQ
rng.each_with_yx {|cell, y, x|
  case x
  when 0  # P
    data, phonetic = ary.shift
    cell.Data = data
    cell.PhoneticText.Text = phonetic
    if y >= 2  # RsڂƂSsڂ́Aӂ肪ȕ\on
      cell.PhoneticText.Visible = 1
    end
  when 1  # Q
    cell.Data = 'x'  # Kȕ(Ȃł悢)
    cell.Formula = '=PHONETIC(RC[-1])'  # ׃Ẑӂ肪Ȃ𓾂
  end
}
ss.col[1] = eWidth(16)  # Qڂ̕16
wb.push(ss)

    # \
ary = [%w(1 awk perl),
    %w(2 fortran cobol),
    %w(3 python ruby)]
ss = ExlSheet.new(ary, "#14 \")
ss.col[1] = eHidden(1)  # Qڂ\
ss.row[1] = eHidden(1)  # Qsڂ\
wb.push(ss)

    # nCp[N
ary = [
  %w(r} http://jp.rubyist.net/magazine/),
  %w(oώYƏ http://www.meti.go.jp/)]
ss = ExlSheet.new
ss.name = "#15 nCp[N"
ss.range(0,0, 1,0).each {|cell|
  data, href = ary.shift
  cell.Data = data
  cell.HRef = href
}
wb.push(ss)

    # ʃV[g̃Rs[ƊOgr
ss = ExlSheet.new
ss.name = "#16 ʃV[g̃Rs[ƊOgr"
rng = ss.copy_from(1,0, wb.sheets[0])
rng.framebox
wb.push(ss)

## [NubN̏o
wb.output_xml "test.xml"
